#!/usr/bin/ksh93
#############################################################
# Program:	chUserPasswd.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.2	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

####  POST form: read from standard input
read -r -- QUERY_STRING

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><H2>Changing user password for ${USERID}</H2></P>"

################################################################

################################################################
####	First check the password protection parameters
################################################################

chkvalue "${USERID}"		"User ID"
chkvalue "${PASSWORD}"		"User Password"
chkvalue "${NEW_PASSWORD}"	"User New Password"
chkvalue "${NEW_RETYPEPW}"	"User Retyped New Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"

USRTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}chUserPasswd${$}.tmp"
rm -f "${TMPFILE}"
/usr/sbin/htpasswd2 -b -s -c "${USRTMPFILE}" "${USERID}" "${NEW_PASSWORD}" >/dev/null 2>&1

# print -- "USRPWDFILE=${USRPWDFILE}<BR>"
# print -- "HTPWDFILE=${HTPWDFILE}<BR>"

  if [[ -f "${USRTMPFILE}" ]]
  then

    chmod 600 "${USRTMPFILE}"

    if grep "^${USERID}:" "${USRPWDFILE}" | head -1 | diff "${USRTMPFILE}" - > /dev/null 2>&1
    then
      print -- "<BR>Regular User <I>${USERID}</I> Verified.<BR>"
      EXITLEVEL="0"
    else
      print -- "<BR><STRONG>ERROR:</STRONG> Improper User ID or password.<BR>"
    fi
    rm -f "${USRTMPFILE}"
  else
    print -- "<BR><STRONG>ERROR:</STRONG> Unable to compare User login.<BR>"
  fi

################################################################

if (( ${EXITLEVEL} == 0 ))
then
  if [[ "_${NEW_PASSWORD}" == "_${NEW_RETYPEPW}" ]]
  then
    if [[ -f "${HTPWDFILE}" ]]
    then
      touch "${HTPWDFILE}" 2>&1
      chmod 600 "${HTPWDFILE}" 2>&1
      /usr/sbin/htpasswd2 -b -s "${HTPWDFILE}" "${USERID}" "${NEW_PASSWORD}" 2>&1
    fi
    touch "${USRPWDFILE}" 2>&1
    chmod 600 "${USRPWDFILE}" 2>&1
    /usr/sbin/htpasswd2 -b -s -c "${USRPWDFILE}" "${USERID}" "${NEW_PASSWORD}" > /dev/null 2>&1
  
    print -- "<P><STRONG>"
    print -- "User Password for \"${USERID}\" has been changed.<BR>"
    print -- "</STRONG></P>"
  else
    print -- "<P><STRONG>ERROR: Passwords do not match. Go back and try again.</STRONG></P>"
  fi
fi
  
################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
