#!/usr/bin/ksh93
#############################################################
# Program:	mkDirMap.cgi
# Version:	0.2
#               Copyright 2006, All Rights Reserved
#
# Description:	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Display a map of the entire directory structure under control of
kshAuth.  Select a directory to configure using kshAuth utilities.

</FONT</P>
<P><HR></P>"

################################################################

print -- "<P><H2>Directory Structure Map</H2></P>"
print -- "<P><BLOCKQUOTE>"

find ${DOCUMENT_DIR} -type d -print | sort |
while read -r -- FPDN
do
  IFS=$'/'
  DIRS=( ${FPDN#${DOCUMENT_ROOT}} )
  IFS=$' \t\n'

  SUMDIR=""
  for DIR in "${DIRS[@]}"
  do
    URLNAME="${DIR}"
    SUMDIR="${SUMDIR}/${DIR}"
    [[ "_/${DIR}/" == "_${DOCUMENT_BASE}" ]] && SUMDIR=""
    print -- "<A Href=\"/cgi-bin${DOCUMENT_BASE}utilities.cgi?DDDIR=${SUMDIR}\">${URLNAME}</A> / "
  done
  print -- "<BR>"

done
print -- "</BLOCKQUOTE></P>"

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
