#!/usr/bin/ksh93
#############################################################
# Program:	mkUserAuth.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.2	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061028
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

####  POST form: read from standard input
read -r -- QUERY_STRING

parseVars
initializeDoc
displayHeader

defineLocations
BASEDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}"
HTPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
AUTHFILE=".htpasswd"
HTPWDFILE="${HTPWDDIR}${AUTHFILE}"
mkdir -p "${HTPWDDIR}"
HTACCFILE="${DOCUMENT_ROOT}${DOCUMENT_BASE}${DDDIR}.htaccess"
USRPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
USRPWDFILE="${USRPWDDIR}.htpasswd"

linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Enable password protection for the current user authorization structure,
which is normally the current working directory.

</FONT></P>
<P><HR></P>"

################################################################
####	First check the password protection parameters
################################################################

chkvalue "${ADM_USERID}"	"Directory Administrator ID"
chkvalue "${ADM_PASSWORD}"	"Directory Administrator Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"

ADMTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}mkUserAuth${$}.tmp"
rm -f "${ADMTMPFILE}"
/usr/sbin/htpasswd2 -b -s -c "${ADMTMPFILE}" "${ADM_USERID}" "${ADM_PASSWORD}" >/dev/null 2>&1

if [[ -f "${ADMTMPFILE}" ]]
then
  chmod 600 "${ADMTMPFILE}"
  if grep "^${ADM_USERID}:" "${ADMPWDFILE}" | head -1 | diff "${ADMTMPFILE}" - > /dev/null 2>&1
  then
    print -- "<BR>Directory Administrator <I>${ADM_USERID}</I> Verified.<BR>"
    EXITLEVEL="0"
  else
    print -- "<BR><STRONG>ERROR:</STRONG> Improper Directory Administrator ID or password.<BR>"
  fi
  rm -f "${ADMTMPFILE}"
else
  print -- "<BR><STRONG>ERROR:</STRONG> Unable to compare Directory Administrator login.<BR>"
fi

################################################################

if (( ${EXITLEVEL} == 0 ))
then
  if [[ "_${NEW_PASSWORD}" == "_${NEW_RETYPEPW}" ]]
  then

    ACCTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}htaccess${$}.tmp"
    rm -f "${ACCTMPFILE}"
    touch "${ACCTMPFILE}"
    chmod 600 "${ACCTMPFILE}"
    IFS=$'\n'
    while read LINE
    do
        [[ "_${LINE}" == _*([$' \t'])AuthName* ]] && continue
        [[ "_${LINE}" == _*([$' \t'])AuthType* ]] && continue
        [[ "_${LINE}" == _*([$' \t'])AuthUserFile* ]] && continue
        [[ "_${LINE}" == _*([$' \t'])require+([$' \t'])valid-user* ]] && continue
        print -r -- "${LINE}" >> "${ACCTMPFILE}"
    done < "${HTACCFILE}"
    cp -f "${ACCTMPFILE}" "${HTACCFILE}"
    rm -f "${ACCTMPFILE}"

    print -- "AuthName \"kshAuth\"" >> "${HTACCFILE}"
    print -- "AuthType Basic" >> "${HTACCFILE}"
    print -- "AuthUserFile \"${USRPWDFILE}\"" >> "${HTACCFILE}"
    print -- "require valid-user" >> "${HTACCFILE}"

    touch -- "${HTPWDFILE}"
    chmod 600 "${HTPWDFILE}"

    print -- "<P><STRONG>"
    print -- "Password Protection has been enabled for the current authorization structure.<BR>"
    print -- "</STRONG></P>"
  else
    print -- "<P><STRONG>ERROR: Passwords do not match. Go back and try again.</STRONG></P>"
  fi
fi
  

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
